# 
# 	Tianji Li
# 	Hamilton Institute, NUIM
# 	31/07/2007
# 

# ======================================================================
# Define options
# ======================================================================
# ======================================================================
set opt(chan)           Channel/WirelessChannel    ;# channel type
set opt(prop)           Propagation/TwoRayGround ;# radio-propagation model
set opt(netif)          Phy/WirelessPhy            ;# network interface type
set opt(mac)            Mac/802_11e                 ;# MAC type
set opt(ifq)            Queue/DTail/PriQ           ;# interface queue type
set opt(ll)             LL                         ;# link layer type
set opt(ant)            Antenna/OmniAntenna        ;# antenna model
set opt(ifqlen)         [lindex $argv 0]                         ;# max packet in ifq
set opt(adhocRouting)   NOAH                       ;# routing protocol
set opt(x)              20000                      ;# x coordinate of topology
set opt(y)              1000                       ;# y coordinate of topology
set opt(ShortRetryLimit) 11
set opt(LongRetryLimit)  11
set opt(RTSThreshold)    65536
set opt(CWmin)           31
set opt(CWmax)           1023
set opt(SlotTime)        0.000009
set opt(SIFS)            0.000010
set opt(AIFS)            6 
set opt(PktSize)         1000

# set opt(rate)		 108
# set opt(dataRate)        $opt(rate)Mb
# set opt(basicRate)       108Mb
# set opt(PLCPhdrRate)     108Mb

set opt(rate)		 54
set opt(dataRate)        $opt(rate)Mb
set opt(basicRate)       6Mb
set opt(PLCPhdrRate)     6Mb

# set opt(rate)		 11
# set opt(dataRate)        $opt(rate)Mb
# set opt(basicRate)       1Mb
# set opt(PLCPhdrRate)     1Mb

set opt(CBRrate)         $opt(rate)Mb

set opt(stop)           [expr [lindex $argv 5]+1]
set opt(start)          0
set opt(numChannel)     10
set opt(numAP)          19
set opt(numSTALeft)     10
set opt(numShadow)      10
set opt(nn)             [expr $opt(numAP) + $opt(numSTALeft) +  $opt(numShadow)]

set TRUE 1
set FALSE 0

#   Application Characteristics 
#------------------------------------------------------------------------
Agent/TCP               set packetSize_   $opt(PktSize)
# Agent/TCP               set frto_enabled_	1
Agent/TCP               set rtxcur_init_        0.5 ;# the init timeout in seconds
# Agent/TCP               set rtxcur_init_        1 ;# the init timeout in seconds
Application/Traffic/CBR set rate_         $opt(CBRrate)
Application/Traffic/CBR set packetSize_   $opt(PktSize)
Agent/TCP               set curr_rto_        0.0 

# set howmany_ul 0 
set howmany_ul [lindex $argv 7]
# set howmany_dl 10
set howmany_dl [lindex $argv 6]
set tcpvariant [lindex $argv 8]




Agent/TCP	set signal_on_empty_ TRUE

# PHY
#------------------------------------------------------------------------
Phy/WirelessPhy set CPThresh_   20000.0     ;#capture threshold (db)
Phy/WirelessPhy set CSThresh_   2.28255e-11   ;#200m
Phy/WirelessPhy set RXThresh_   3.652e-10     ;#100m
Phy/WirelessPhy set Pt_         7.214e-3      ;#

# MAC
#------------------------------------------------------------------------
Mac/802_11e set NumRetryOut_       0

Mac/802_11e set ThruAP0_           0.0
Mac/802_11e set ThruAP1_           0.0
Mac/802_11e set ThruAP2_           0.0
Mac/802_11e set ThruAP3_           0.0
Mac/802_11e set ThruAP4_           0.0
Mac/802_11e set ThruAP5_           0.0
Mac/802_11e set ThruAP6_           0.0
Mac/802_11e set ThruAP7_           0.0
Mac/802_11e set ThruAP8_           0.0
Mac/802_11e set ThruAP9_           0.0
Mac/802_11e set ThruAP10_           0.0
Mac/802_11e set ThruAP11_           0.0
Mac/802_11e set ThruAP12_           0.0
Mac/802_11e set ThruAP13_           0.0
Mac/802_11e set ThruAP14_           0.0
Mac/802_11e set ThruAP15_           0.0
Mac/802_11e set ThruAP16_           0.0
Mac/802_11e set ThruAP17_           0.0
Mac/802_11e set ThruAP18_           0.0
Mac/802_11e set ThruAP19_           0.0


Mac/802_11e set NumAP0_           0
Mac/802_11e set NumAP1_           0
Mac/802_11e set NumAP2_           0
Mac/802_11e set NumAP3_           0
Mac/802_11e set NumAP4_           0
Mac/802_11e set NumAP5_           0
Mac/802_11e set NumAP6_           0
Mac/802_11e set NumAP7_           0
Mac/802_11e set NumAP8_           0
Mac/802_11e set NumAP9_           0
Mac/802_11e set NumAP10_           0
Mac/802_11e set NumAP11_           0
Mac/802_11e set NumAP12_           0
Mac/802_11e set NumAP13_           0
Mac/802_11e set NumAP14_           0
Mac/802_11e set NumAP15_           0
Mac/802_11e set NumAP16_           0
Mac/802_11e set NumAP17_           0
Mac/802_11e set NumAP18_           0
Mac/802_11e set NumAP19_           0
Mac/802_11e set NumFromNode0_           0
Mac/802_11e set NumFromNode1_           0
Mac/802_11e set NumFromNode2_           0
Mac/802_11e set NumFromNode3_           0
Mac/802_11e set NumFromNode4_           0
Mac/802_11e set NumFromNode5_           0
Mac/802_11e set NumFromNode6_           0
Mac/802_11e set NumFromNode7_           0
Mac/802_11e set NumFromNode8_           0
Mac/802_11e set NumFromNode9_           0
Mac/802_11e set NumFromNode10_           0
Mac/802_11e set NumFromNode11_           0
Mac/802_11e set NumFromNode12_           0
Mac/802_11e set NumFromNode13_           0
Mac/802_11e set NumFromNode14_           0
Mac/802_11e set NumFromNode15_           0
Mac/802_11e set NumFromNode16_           0
Mac/802_11e set NumFromNode17_           0
Mac/802_11e set NumFromNode18_           0
Mac/802_11e set NumFromNode19_           0


Mac/802_11e set THRind_             0.0

Mac/802_11e set Wq_                     [lindex $argv 10]
Mac/802_11e set Tdrain_                 [lindex $argv 11]
Queue/DTail/PriQ set Wq_  [lindex $argv 10]

Mac/802_11e set Ns_                 0
Mac/802_11e set Nc_                 0
Mac/802_11e set Ni_                 0
Mac/802_11e set Ts_                 0.0
Mac/802_11e set Ti_                 0.0
Mac/802_11e set Ri_                 0.0
Mac/802_11e set Rb_                 0.0
Mac/802_11e set Rs_                 0.0

Mac/802_11e set BER_                 0.0


Mac/802_11e set PLCPDataRate_      $opt(PLCPhdrRate)
Mac/802_11e set basicRate_         $opt(basicRate)
Mac/802_11e set dataRate_          $opt(dataRate)
Mac/802_11e set CWMin_             $opt(CWmin)
Mac/802_11e set CWMax_             $opt(CWmax)
Mac/802_11e set SlotTime_          $opt(SlotTime)
Mac/802_11e set SIFS_              $opt(SIFS)
Mac/802_11e set ShortRetryLimit_   $opt(ShortRetryLimit)
Mac/802_11e set LongRetryLimit_    $opt(LongRetryLimit)
Mac/802_11e set RTSThreshold_ 	  $opt(RTSThreshold)
# Mac/802_11e set PreambleLength_        144 ;# 144 bit
# Mac/802_11e set PLCPHeaderLength_      48  ;# 48 bits





# create simulator instance
set ns_   [new Simulator]


set step 0.01
$ns_ at $step "print_stuff"




#------------------------------------------------------------------------
# set up for hierarchical routing
$ns_ node-config -addressType hierarchical
# number of domains
AddrParams set domain_num_ $opt(numChannel)

# number of clusters in each domain
lappend cluster_num 1 1 1 1 1 1 1 1 1 1
AddrParams set cluster_num_ $cluster_num

# number of nodes in each cluster
lappend eilastlevel 50 50 50 50 50 50 50 50 50 50
AddrParams set nodes_num_ $eilastlevel ;# of each domain
#------------------------------------------------------------------------




set tracefd  [open mul.tr w]
set namtrace [open mul.nam w]
$ns_ trace-all $tracefd
$ns_ namtrace-all-wireless $namtrace $opt(x) $opt(y)

# Create topography object
for {set i 0} {$i < $opt(numChannel)} {incr i} {
	set chan($i) [new $opt(chan)]
}
set topo   [new Topography]

# define topology
$topo load_flatgrid $opt(x) $opt(y)

# create God
create-god [expr $opt(nn)]

# configure for base-station node
$ns_ node-config -adhocRouting $opt(adhocRouting) \
                 -llType $opt(ll) \
                 -macType $opt(mac) \
                 -ifqType $opt(ifq) \
                 -ifqLen $opt(ifqlen) \
                 -antType $opt(ant) \
                 -propType $opt(prop) \
                 -phyType $opt(netif) \
		 -topoInstance $topo \
                 -wiredRouting ON\
		 -agentTrace OFF \
                 -ifqTrace OFF \
                 -routerTrace OFF \
                 -macTrace OFF 






#########################################################################
#create APs
#########################################################################

for {set i 0} {$i < $opt(numAP)} {incr i} {
# puts "node=$i, channel=[expr ($i / 2) + ($i % 2)]"
        $ns_ node-config -channel $chan([expr ($i / 2) + ($i % 2)])
	LL set localmacDA_ -1
	set aaa [expr $i % 2]
	if { $aaa==1 } {
		LL set globalmacDA_ [expr $i+1]
	} else {
		LL set globalmacDA_ [expr $i-1]
	}
# puts "node=$i, address=[expr ($i+1) / 2].0.[expr 49-($i+1) % 2], location=[expr ($i/2)*100.0]"
	set BS($i) [$ns_ node [expr ($i+1) / 2].0.[expr 49-($i+1) % 2]]
	$BS($i) random-motion 0               ;# disable random motion
	$BS($i) set X_ [expr ($i/2)*100.0]
	$BS($i) set Y_ 0.0
	$BS($i) set Z_ 0.0


# 	$BS($i) setPriQ 0 3 3 1 10
	$BS($i) setPriQ 0 3 7 2 0
# 	$BS($i) setPriQ 0 15 63 2 10
# 	$BS($i) setPriQ 0 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$BS($i) setPriQ 1 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$BS($i) setPriQ 2 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$BS($i) setPriQ 3 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0

	set ifq($i) [$BS($i) monitor-ifq]
	#$ifq($i) Prio 0 QueueSize [lindex $argv 1]
	$ifq($i) Prio 0 QueueSize 10000
	$ifq($i) Prio 1 QueueSize [lindex $argv 1]
	$ifq($i) Prio 2 QueueSize [lindex $argv 1]
	$ifq($i) Prio 3 QueueSize [lindex $argv 1]
}

# the 20 AP is not useful
	set BS(19) [$ns_ node 9.0.9]
	$BS(19) random-motion 0               ;# disable random motion
	$BS(19) set X_ 1000.0
	$BS(19) set Y_ 0.0
	$BS(19) set Z_ 0.0

 	$BS(17) set X_ 10000.0


#create links between APs
for {set i 0} {$i < [expr $opt(numAP)-1] } {incr i 2} {
        $ns_ duplex-link $BS($i) $BS([expr $i+1]) 100Mb [lindex $argv 9]ms DropTail
	$ns_ queue-limit $BS($i) $BS([expr $i+1]) 10000
# 	$ns_ queue-limit $BS($i) $BS([expr $i+1]) [lindex $argv 6] 
}



#########################################################################
# #create STAs
#########################################################################
$ns_ node-config -wiredRouting OFF



######################### 2 hop #############################
for {set i 0} {$i < $opt(numSTALeft) } {incr i} {
	$ns_ node-config -channel $chan(8)
	LL set localmacDA_  -1
	LL set globalmacDA_ 16
	set node_($i) [ $ns_ node 8.0.[expr $i+$opt(numShadow)] ]
	$node_($i) set X_ 700.0
	$node_($i) set Y_ 0.0
	$node_($i) set Z_ 0.0
	$node_($i) base-station [AddrParams addr2id [$BS(16) node-addr]]

# 	$node_($i) setPriQ 0 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$node_($i) setPriQ 0 3 7 2 0
# 	$node_($i) setPriQ 0 15 63 2 10
# 	$node_($i) setPriQ 0 3 3 1 0
	$node_($i) setPriQ 1 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$node_($i) setPriQ 2 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
	$node_($i) setPriQ 3 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0
}




#########################################################################
# #create shadow 
#########################################################################
$ns_ node-config -wiredRouting OFF



######################### 2 hop #############################
for {set i 0} {$i < $opt(numShadow) } {incr i} {
	$ns_ node-config -channel $chan(8)
	LL set localmacDA_  -1
	LL set globalmacDA_ 16
	set shadow_($i) [ $ns_ node 8.0.$i ]
	$shadow_($i) set X_ 700.0
	$shadow_($i) set Y_ 0.0
	$shadow_($i) set Z_ 0.0
	$shadow_($i) base-station [AddrParams addr2id [$BS(16) node-addr]]

# 	$shadow_($i) setPriQ 0 3 3 1 0
	$shadow_($i) setPriQ 0 3 7 2 0
# 	$shadow_($i) setPriQ 0 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0  ;# DL DATA
	$shadow_($i) setPriQ 1 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0  ;# UL ACK
	$shadow_($i) setPriQ 2 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0  ;# UL DATA
	$shadow_($i) setPriQ 3 $opt(CWmin) $opt(CWmax) $opt(AIFS) 0  ;# DL ACK
}






#########################################################################
#create applications
#########################################################################

set         rng          [new RNG]
$rng        seed         0
set flowid 0
set TCP_WINDOWINIT [lindex $argv 2]
# set TCP_SSTHRESH   [lindex $argv 2]
set TCP_SSTHRESH   128
set TCP_WINDOW     [lindex $argv 3]

#-------------------------------------------------------------
# end-to-end traffic : TCP
#-------------------------------------------------------------




###################### Upload ########################
for {set i 0} {$i < $opt(numSTALeft) } {incr i} {
	set tcp_l2r($flowid) [new Agent/TCP/Sack1]
	$tcp_l2r($flowid) set class_ 1
	$tcp_l2r($flowid) set prio_  1 
	$tcp_l2r($flowid) set ssthresh_     $TCP_SSTHRESH
	$tcp_l2r($flowid) set window_       $TCP_WINDOW
	$tcp_l2r($flowid) set windowInit_   $TCP_WINDOWINIT
	$tcp_l2r($flowid) set fid_ $flowid

	set sink_l2r($flowid) [new Agent/TCPSink/Sack1]
	$sink_l2r($flowid) set class_ 0
	$sink_l2r($flowid) set prio_  0
	$ns_ attach-agent $node_($i) $tcp_l2r($flowid)
	$ns_ attach-agent $BS(17) $sink_l2r($flowid)
	$ns_ connect $tcp_l2r($flowid) $sink_l2r($flowid)

	set app_l2r($flowid) [new Application/FTP]
	$app_l2r($flowid) attach-agent $tcp_l2r($flowid)
	if { $i < $howmany_ul } {
  		$ns_ at $opt(start).[$rng next-random] "$app_l2r($flowid) start"
	}
	set flowid [expr $flowid + 1]
}



###################### Download ########################
set i 0
for {set i 0} {$i < $opt(numSTALeft) } {incr i} {

	set tcp_r2l($flowid) [new Agent/TCP/Sack1]
	$tcp_r2l($flowid) set class_ 1
	$tcp_r2l($flowid) set prio_  1 
	$tcp_r2l($flowid) set ssthresh_     $TCP_SSTHRESH
	$tcp_r2l($flowid) set window_       $TCP_WINDOW
	$tcp_r2l($flowid) set windowInit_   $TCP_WINDOWINIT
	$tcp_r2l($flowid) set fid_   $flowid

	set sink_r2l($flowid) [new Agent/TCPSink/Sack1]
	$sink_r2l($flowid) set prio_  0
	$sink_r2l($flowid) set class_ 0

	$ns_ attach-agent $BS(17) $tcp_r2l($flowid)
	$ns_ attach-agent $node_($i) $sink_r2l($flowid)
	$ns_ connect $tcp_r2l($flowid) $sink_r2l($flowid)

	set app_r2l($flowid) [new Application/FTP]
	$app_r2l($flowid) attach-agent $tcp_r2l($flowid)
	if { $i < $howmany_dl } {
		$ns_ at $opt(start).[$rng next-random] "$app_r2l($flowid) start" 
		if { $i == 0 } {
			set f_cwnd_dl [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].cwnd.dl.$flowid.sta.queue.[lindex $argv 1].txt" "w"]
			set f_rtt_dl  [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].rtt.dl.$flowid.sta.queue.[lindex $argv 1].txt" "w"]
			set f_srtt_dl  [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].srtt.dl.$flowid.sta.queue.[lindex $argv 1].txt" "w"]
			set f_throughput_dl [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].throughput.dl.$flowid.sta.queue.[lindex $argv 1].txt" "w"]
			close $f_cwnd_dl
			close $f_rtt_dl
			close $f_srtt_dl
			close $f_throughput_dl
		}
	}
	set flowid [expr $flowid + 1]
}


set f_sum_cwnd [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].sum.cwnd.sta.queue.[lindex $argv 1].txt" "w"]
close $f_sum_cwnd

set f_sum_thru [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].sum.thru.sta.queue.[lindex $argv 1].txt" "w"]
close $f_sum_thru

set f_dl_sum [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].dl.sum.sta.queue.[lindex $argv 1].txt" "w"]
close $f_dl_sum

set f_queue_size [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].AP.queue.size.sta.queue.[lindex $argv 1].txt" "w"]
close $f_queue_size

set f_mac_loss [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].MAC.loss.sta.queue.[lindex $argv 1].txt" "w"]
close $f_mac_loss

set f_overflow [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].overflow.sta.queue.[lindex $argv 1].txt" "w"]
close $f_overflow

set f_rto_times [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].RTO.times.sta.queue.[lindex $argv 1].txt" "w"]
close $f_rto_times





#########################################################################
# Result output routines
#########################################################################

# Tell all nodes when the simulation ends
$ns_ at $opt(start).000 "assignRouting"
$ns_ at $opt(stop).000 "stop"
$ns_ at [expr $opt(stop).000/2] "forthroughput"
# $ns_ at $opt(stop).000 "shadowfairness"
$ns_ at $opt(stop).0 "STALeftfairness"

# Reset all nodes
for {set i 0} {$i < $opt(numAP) } {incr i} {
    $ns_ at $opt(stop).0001 "$BS($i) reset";
}
for {set i 0} {$i < $opt(numSTALeft) } {incr i} {
    $ns_ at $opt(stop).0001 "$node_($i) reset";
}
for {set i 0} {$i < $opt(numShadow) } {incr i} {
	$ns_ at $opt(stop).0001 "$shadow_($i) reset";
}

$ns_ at $opt(stop).0002 "puts \"NS EXITING...\" ; $ns_ halt"

############################# fairness function #################################
proc shadowfairness {} {
    global ns_ opt shadow_ argv

	set sum 0.0
	set squaresum 0.0
	set temp 0.0
 
# 	puts "----------------------------------------------------------------------"
	set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
	puts $f_mulChan "----------------------------------------------------------------------"
	close $f_mulChan
	for {set i 0} {$i < $opt(numShadow) } {incr i} {
		set mac [$shadow_($i) getMac 0]
		set throughput($i)  [expr [$mac set THRind_]/$opt(stop)]
# 		if { $throughput($i) > 0.001 } {
			set sum [expr $sum + $throughput($i)]
			set squaresum [expr $squaresum+[expr $throughput($i)*$throughput($i)]]
			lappend temp  [string range $throughput($i) 0 6]
# 			puts "shadow $i's throughput =  [string range $throughput($i) 0 6]"
# 		}
	}
	if { $temp > 0.0 } {
			set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
			puts $temp
			puts $f_mulChan "$temp"
			close $f_mulChan
	}

	if { $squaresum > 0.0 } {
		set nominator [expr $sum*$sum]
		set denominator [expr $opt(numShadow)*$squaresum]
		set shadowfairness [expr $nominator/$denominator]
		
		set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
		puts "download fairness of shadows  = $shadowfairness, average throughput=[string range [expr $sum/$opt(numShadow)] 0 6]"
		puts $f_mulChan "download fairness of shadows = [string range $shadowfairness 0 4], average throughput=[string range [expr $sum/$opt(numShadow)] 0 4] "
		puts $f_mulChan "----------------------------------------------------------------------"
		close $f_mulChan
	} else {
		set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
		puts "download fairness of shadows  = 0"
		puts $f_mulChan "download fairness of shadows = 0"
		puts $f_mulChan "----------------------------------------------------------------------"
		close $f_mulChan
	}

}
#############################################################################
proc STALeftfairness {} {
    global ns_ opt node_ argv howmany_dl howmany_ul sink_r2l t_thru_dl step

 
# 	puts "----------------------------------------------------------------------"
	set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
	puts $f_mulChan ""
	puts $f_mulChan ""
	puts $f_mulChan ""
	puts $f_mulChan "========================================================================"
	close $f_mulChan

	set flowid $opt(numSTALeft)
	for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
		set temp($flowid)      0.0
		set flowid [expr $flowid + 1]
	}
	set flowid $opt(numSTALeft)
	set thru 0.0
	set now [$ns_ now]
	for {set i 0} {$i < $howmany_dl} {incr i} {
# 		set temp($flowid)  [expr [$sink_r2l($flowid) set bytes_].0*8/1000000/$now]
		set temp($flowid)  [string range [expr [$sink_r2l($flowid) set bytes_].0*8/1000000] 0 6]
# puts "$now $temp($flowid), $t_thru_dl($flowid), $flowid"

		set thru  [expr $thru + $t_thru_dl($flowid)]
		set flowid [expr $flowid + 1]
	}
}



############################# fairness function #################################



############################# stop function #################################
proc stop {} {
    global ns_ tracefd namtrace node_ opt shadow_ BS argv sink_r2l sink_l2r tcp_r2l tcp_l2r ul_total_rtt dl_total_rtt count howmany_ul howmany_dl tcpvariant ttt  max_srtt sum_dl


    set mac [ $BS(0) getMac 0 ]

    set thruAP0    [string range   [expr [$mac set NumAP0_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP1    [string range   [expr [$mac set NumAP1_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP2    [string range   [expr [$mac set NumAP2_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP3    [string range   [expr [$mac set NumAP3_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP4    [string range   [expr [$mac set NumAP4_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP5    [string range   [expr [$mac set NumAP5_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP6    [string range   [expr [$mac set NumAP6_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP7    [string range   [expr [$mac set NumAP7_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP8    [string range   [expr [$mac set NumAP8_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP9    [string range   [expr [$mac set NumAP9_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP10    [string range   [expr [$mac set NumAP10_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP11    [string range   [expr [$mac set NumAP11_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP12    [string range   [expr [$mac set NumAP12_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP13    [string range   [expr [$mac set NumAP13_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP14    [string range   [expr [$mac set NumAP14_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP15    [string range   [expr [$mac set NumAP15_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP16    [string range   [expr [$mac set NumAP16_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP17    [string range   [expr [$mac set NumAP17_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP18    [string range   [expr [$mac set NumAP18_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruAP19    [string range   [expr [$mac set NumAP19_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode0  [string range [expr [$mac set NumFromNode0_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode1  [string range [expr [$mac set NumFromNode1_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode2  [string range [expr [$mac set NumFromNode2_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode3  [string range [expr [$mac set NumFromNode3_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode4  [string range [expr [$mac set NumFromNode4_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode5  [string range [expr [$mac set NumFromNode5_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode6  [string range [expr [$mac set NumFromNode6_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode7  [string range [expr [$mac set NumFromNode7_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode8  [string range [expr [$mac set NumFromNode8_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode9  [string range [expr [$mac set NumFromNode9_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode10  [string range [expr [$mac set NumFromNode10_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode11  [string range [expr [$mac set NumFromNode11_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode12  [string range [expr [$mac set NumFromNode12_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode13  [string range [expr [$mac set NumFromNode13_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode14  [string range [expr [$mac set NumFromNode14_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode15  [string range [expr [$mac set NumFromNode15_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode16  [string range [expr [$mac set NumFromNode16_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode17  [string range [expr [$mac set NumFromNode17_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode18  [string range [expr [$mac set NumFromNode18_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]
    set thruNode19  [string range [expr [$mac set NumFromNode19_].0*$opt(PktSize)*8/1000000/$opt(stop)] 0 6]

    set f_mulChan [open "txt.dcf.mulChan.txt" "a"]
#     puts "$thruAP0	$thruAP1	$thruAP2	$thruAP3	$thruAP4	$thruAP5	$thruAP6	$thruAP7	$thruAP8	$thruAP9	$thruAP10	$thruAP11	$thruAP12	$thruAP13	$thruAP14	$thruAP15	$thruAP16	$thruAP17	$thruAP18	$thruAP19	$thruNode0	$thruNode1	$thruNode2	$thruNode3	$thruNode4	$thruNode5	$thruNode6	$thruNode7	$thruNode8	$thruNode9"
#     puts $f_mulChan "$thruAP0	$thruAP1	$thruAP2	$thruAP3	$thruAP4	$thruAP5	$thruAP6	$thruAP7	$thruAP8	$thruAP9	$thruAP10	$thruAP11	$thruAP12	$thruAP13	$thruAP14	$thruAP15	$thruAP16	$thruAP17	$thruAP18	$thruAP19	$thruNode0	$thruNode1	$thruNode2	$thruNode3	$thruNode4	$thruNode5	$thruNode6	$thruNode7	$thruNode8	$thruNode9"
 

    set aaa "+DATE: %m/%d/%Y, TIME: %H:%M:%S"
    puts $f_mulChan "============================================================================"
    puts $f_mulChan "=================         TCP $tcpvariant"
    puts $f_mulChan "=================         STA queue = $opt(ifqlen)"
    puts $f_mulChan "=================         AP queue  = [lindex $argv 1]"
    puts $f_mulChan "=================         Init cwnd = [lindex $argv 2]"
    puts $f_mulChan "=================         SSTHRESH  = [lindex $argv 2]"
    puts $f_mulChan "=================         Max cwnd  = [lindex $argv 3]"
    puts $f_mulChan "=================         rate  = $opt(rate)"
    puts $f_mulChan "=================         howmanyul  = $howmany_ul"
    puts $f_mulChan "=================         howmanydl  = $howmany_dl"
    puts $f_mulChan "=================         Run  $opt(stop) seconds"
    puts $f_mulChan "=================         System time(month/day/year): [exec date $aaa]"
    puts $f_mulChan "============================================================================"

    puts $f_mulChan  "$thruAP0	$thruAP1	$thruAP2	$thruAP3	$thruAP4	$thruAP5	$thruAP6	$thruAP7	$thruAP8	$thruAP9"
    puts $f_mulChan  "$thruAP10	$thruAP11	$thruAP12	$thruAP13	$thruAP14	$thruAP15	$thruAP16	$thruAP17	$thruAP18	$thruAP19"
    puts $f_mulChan  "$thruNode0	$thruNode1	$thruNode2	$thruNode3	$thruNode4	$thruNode5	$thruNode6	$thruNode7	$thruNode8	$thruNode9"
    puts $f_mulChan  "$thruNode10	$thruNode11	$thruNode12	$thruNode13	$thruNode14	$thruNode15	$thruNode16	$thruNode17	$thruNode18	$thruNode19"
    puts $f_mulChan  "----------------------------------------------------------------------------"


	set aaaa [$BS(16) monitor-ifq]
	set mac16 [$BS(16) getMac 0 ]
	set NumRetryOut    [$mac16 set NumRetryOut_]
	puts $f_mulChan  "----------------------------------------------------------------------------"
	puts $f_mulChan "Queue 1 overflow = [$aaaa getValue 1 NumAllOverflew]" 
	puts $f_mulChan "Queue 1 null times = [$aaaa getValue 1 NumNullQueueSize]" 
	puts $f_mulChan "Queue 1 null rate = [string range [expr [$aaaa getValue 1 NumNullQueueSize].0/[$aaaa getValue 1 NumArrived]] 0 6]" 
	puts $f_mulChan "Queue 1 utilization rate = [string range [expr 1-[$aaaa getValue 1 NumNullQueueSize].0/[$aaaa getValue 1 NumArrived]] 0 6]" 
	puts $f_mulChan "MAC layer retrys = $NumRetryOut"
	puts $f_mulChan  "----------------------------------------------------------------------------"

    set ul_sum 0
    set flowid 0
    for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
	if { $i<$howmany_ul } {
		set ul_sum [expr $ul_sum + [$sink_l2r($flowid) set bytes_].0*8/1000000/$opt(stop)]
	}
	set flowid [expr $flowid + 1]
    }

    set dl_sum_total 0.0
    for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
	if { $i<$howmany_dl } {
		set dl_sum_total [expr $dl_sum_total + [$sink_r2l($flowid) set bytes_].0*8/1000000]
	}
	set flowid [expr $flowid + 1]
    }

   # puts $f_mulChan "-----------------------------------------------------------------------"
   # puts $f_mulChan "Aggregate system throughput = [string range [expr $ul_sum+$dl_sum] 0 6]"
   # puts $f_mulChan "Smoothed RTT of DL 1 = [string range [$tcp_r2l(10) set srtt_] 0 4]"
   # puts $f_mulChan "Aggregate UL throughput = [string range [expr $ul_sum] 0 6]"
   # puts $f_mulChan "Aggregate DL throughput = [string range $sum_dl 0 6]"
   # puts $f_mulChan "-----------------------------------------------------------------------"

    set fresult [open "result.thru.drain.time.txt" "a"]
    puts -nonewline $fresult "[string range [expr ($dl_sum_total-$sum_dl)/($opt(stop)/2)] 0 6]	"
    close $fresult 
    
    set fresult [open "result.delay.drain.time.txt" "a"]
    puts -nonewline $fresult "$max_srtt	"
    close $fresult 	



    exec rm -rf mul.nam mul.tr
}
############################# stop function #################################




############################# routing function #################################

proc assignRouting {} {
	global BS ns_ opt

# tell $BS(2) to use wireless for going to node 0
# 	$BS(2) delete-route 0
# 	$BS(2) add-route 0 [[$BS(2) set classifier_] cmd classifier 2]
	set aaa 0
	for {set i 2} {$i < [expr $opt(numAP)-2] } {incr i 2} { ;# 2, 4, 6, ..., 16
		for {set j 0} {$j <= $aaa} {incr j} {               ;# 0, 1, 2, ..., 7  
# puts "i=$i, j=$j, aaa=$aaa"
			$BS($i) delete-route $j
			$BS($i) add-route $j [[$BS($i) set classifier_] cmd classifier 2]
		}
		set aaa [expr $aaa+1]
	}
# tell $BS(1) to use wireless for going to node 2
# 	$BS(1) delete-route 2
# 	$BS(1) add-route 2 [[$BS(1) set classifier_] cmd classifier 2]
	set aaa 2
	for {set i 1} {$i < [expr $opt(numAP)-3] } {incr i 2} { ;# 1, 3, 5, ..., 15
		for {set j $aaa} {$j < 10} {incr j} {              ;# 2, 3, 4, ..., 9 
# puts "i=$i, j=$j, aaa=$aaa"
			$BS($i) delete-route $j
			$BS($i) add-route $j [[$BS($i) set classifier_] cmd classifier 2]
		}
		set aaa [expr $aaa+1]
	}
}
############################# routing function #################################










set max_srtt 0.0	
set ul_total_rtt      0
set dl_total_rtt      0
set flowid 0
for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
	set flowid [expr $flowid + 1]
}
for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
	set t_thru_dl($flowid)      0.0
	set dl_temp_throughput($flowid)      0.0
	set flowid [expr $flowid + 1]
}

set count 0




set sum_dl 0.0
proc forthroughput {} {
        global ns_ opt step sink_r2l sink_l2r tcp_r2l tcp_l2r ul_total_rtt dl_total_rtt count f_throughput f_cwnd f_rtt howmany_ul howmany_dl argv tcpvariant dl_temp_throughput BS sum_dl minQueue maxQueue currQueue max_srtt
	
	set flowid $opt(numSTALeft) 
	set sum_dl 0.0
	for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
		if { $i < $howmany_dl } {
 			set dl_temp_throughput($flowid)  [string range [expr [$sink_r2l($flowid) set bytes_].0*8/1000000] 0 6]

			set sum_dl [expr $dl_temp_throughput($flowid) + $sum_dl]
		}
		set flowid [expr $flowid + 1]
	}
}








proc print_stuff { } {
        global ns_ node_ opt step sink_r2l sink_l2r tcp_r2l tcp_l2r ul_total_rtt dl_total_rtt count f_throughput f_cwnd f_rtt howmany_ul howmany_dl argv tcpvariant dl_temp_throughput BS sum_dl minQueue maxQueue currQueue max_srtt
        set now [$ns_ now]

        set t_now  [string range $now 0 5]


	set flowid 0
	set tmp_ul_total_rtt 0
	set tmp_dl_total_rtt 0

	set sum_cwnd 0
	set sum_thru 0

	set macRetries 0
	for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
		set tmp_ul_total_rtt [expr $tmp_ul_total_rtt + [$tcp_l2r($flowid) set rtt_]]
		if { $i < $howmany_ul } {
			set mac($i)        [$node_($i) getMac 0]
			set macRetries     [expr $macRetries+[$mac($i) set NumRetryOut_]]
# 			set t_cwnd_ul  [string range [expr [$tcp_r2l($flowid) set cwnd_]*1] 0 4]

# 			set sum_cwnd  [expr $sum_cwnd + $t_cwnd_ul]
		}
		set flowid [expr $flowid + 1]
	}

	set sum_dl_local 0.0
	for {set i 0} {$i < $opt(numSTALeft)} {incr i} {
		set tmp_dl_total_rtt [expr $tmp_dl_total_rtt + [$tcp_r2l($flowid) set rtt_]]
		#set sum_dl 0.0
		if { $i < $howmany_dl } {
			set t_cwnd_dl  [string range [expr [$tcp_r2l($flowid) set cwnd_]*1] 0 4]
			set t_rtt_dl  [string range [$tcp_r2l($flowid) set rtt_] 0 4]
			set t_srtt_dl  [string range [$tcp_r2l($flowid) set srtt_] 0 4]

			if { $i == 0 } {
				if { $t_srtt_dl > $max_srtt } { set max_srtt $t_srtt_dl }
			}

 			set t_thru_dl($flowid) $dl_temp_throughput($flowid)
 			set dl_temp_throughput($flowid)  [string range [expr [$sink_r2l($flowid) set bytes_].0*8/1000000] 0 6]
 			set t_thru_dl($flowid) [expr ($dl_temp_throughput($flowid)-$t_thru_dl($flowid))/$step]

# puts "[$tcp_r2l($flowid) set maxburst_]"
# puts "ack: [$tcp_r2l($flowid) set ack_], seqno: [$tcp_r2l($flowid) set seqno_], t_seqno_: [$tcp_r2l($flowid) set t_seqno_]"
#			set t_thru_dl($flowid)  [string range [expr [$sink_r2l($flowid) set bytes_].0*8/1000000/$now] 0 6]
			set sum_dl_local [expr $t_thru_dl($flowid) + $sum_dl_local]
			set sum_cwnd  [expr $sum_cwnd + $t_cwnd_dl]
			set sum_thru  [expr $sum_thru + $t_thru_dl($flowid)]

			if { $i == 0 } {
				set f_cwnd_dl [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].cwnd.dl.$flowid.sta.queue.[lindex $argv 1].txt" "a"]
				set f_rtt_dl  [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].rtt.dl.$flowid.sta.queue.[lindex $argv 1].txt" "a"]
				set f_srtt_dl  [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].srtt.dl.$flowid.sta.queue.[lindex $argv 1].txt" "a"]
				set f_throughput_dl [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].throughput.dl.$flowid.sta.queue.[lindex $argv 1].txt" "a"]
	
				puts $f_cwnd_dl "$t_now $t_cwnd_dl"
				puts $f_rtt_dl "$t_now $t_rtt_dl"
				puts $f_srtt_dl "$t_now $t_srtt_dl"
				puts $f_throughput_dl "$t_now  $t_thru_dl($flowid)"
	
				close $f_cwnd_dl
				close $f_rtt_dl
				close $f_srtt_dl
				close $f_throughput_dl
			}
		}
		set flowid [expr $flowid + 1]
	}
	set tmp_dl_total_rtt [expr $tmp_dl_total_rtt/$opt(numSTALeft)]
	set dl_total_rtt [expr $dl_total_rtt + $tmp_dl_total_rtt]

	set count [expr $count + 1]



# # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
	set temp_ifq [$BS(16) monitor-ifq]

	set f_sum_cwnd [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].sum.cwnd.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_sum_cwnd "$t_now $sum_cwnd"
	close $f_sum_cwnd

	set f_sum_thru [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].sum.thru.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_sum_thru "$t_now $sum_thru"
	close $f_sum_thru

	set f_dl_sum [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].dl.sum.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_dl_sum "$t_now $sum_dl_local"
	close $f_dl_sum

	set f_queue_size [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].AP.queue.size.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_queue_size "$t_now [$temp_ifq getValue 1 QueueSizeInPkts] [$temp_ifq getValue 1 MaxQueueSizeInPkts] [$temp_ifq getValue 1 BB] [$temp_ifq getValue 1 KK]  [$temp_ifq getValue 1 realBB]"
	close $f_queue_size

	set f_rto_times [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].RTO.times.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_rto_times "$t_now [$tcp_r2l(10) set nrexmit_] [$tcp_r2l(10) set curr_rto_]"
	close $f_rto_times

	set mac16 [$BS(16) getMac 0]
	set NumRetryOut    [$mac16 set NumRetryOut_]
	set f_mac_loss [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].MAC.loss.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_mac_loss "$t_now $NumRetryOut $macRetries"
	close $f_mac_loss

	set aaaa           [$BS(16) monitor-ifq]
	set dataOverflow    [$aaaa getValue 1 NumDrops]

	set f_overflow [open "$tcpvariant.ul.$howmany_ul.dl.$howmany_dl.rtt.[lindex $argv 9].overflow.sta.queue.[lindex $argv 1].txt" "a"]
	puts $f_overflow "$t_now $dataOverflow"
	close $f_overflow

        $ns_ at [expr $now + $step] "print_stuff"

}


puts "Starting Simulation..."
$ns_ run

