# ======================================================================
#
# TCL script for New TCP Via Multihop Multichannel Mesh
#
# ======================================================================
# Author:           Tianji Li
# Date:             06/07/2007
# Organization:     Hamilton Institute, NUIM, Ireland
# ======================================================================



############### TXOP ####################
set pkts_short {10}
set ul_pkts_long {300000}
set dl_pkts_long {3000}
set whichone 	     {20}
set howmanyul	     {0 2 4 6 8 10}
set tcpvariant       "sack"
#set tcpvariant       "bic"
# set tcpvariant       "cubic"
set aaa "+DATE(month/day/year): %m/%d/%Y, TIME: %H:%M:%S"
set systemtime       "[exec date $aaa]"
################ TXOP ####################


# set 1stline  "# of DLs:      $howmanydl"
set 1stline  "# of ULs:      $howmanyul"
set 2ndline  "size of AP queue: $whichone"
set 3rdline  "tcp variant:   $tcpvariant"
set 4thline  $systemtime
set 5thline  "pkts in short flows: $pkts_short"
set 6thline  "ul pkts in long flows: $ul_pkts_long"
set 7thline  "dl pkts in long flows: $dl_pkts_long"

set fh_oneChan     "result.adt.txt"

####################################################################
# clear result files
####################################################################
set fresult [open $fh_oneChan "a"]
close $fresult 	

####################################################################
# put an 'enter' at the end of a line
####################################################################
proc new_a_line args {
    global fh_oneChan
    
    set fresult [open $fh_oneChan "a"]
    puts $fresult ""
    close $fresult 	
}


####################################################################
# the first line
####################################################################
proc first_line args {
    global fh_oneChan
        for {set j 0} {$j < [llength "$args"] } {incr j} {
            set fresult1 [open $fh_oneChan "a"]
            puts -nonewline $fresult1 "[lindex $args $j]      "
            close $fresult1
	}
}
new_a_line
new_a_line
new_a_line
new_a_line
first_line "#####################################################################"
new_a_line
first_line $1stline
new_a_line
first_line $2ndline
new_a_line
first_line $3rdline
new_a_line
first_line $4thline
new_a_line
first_line $5thline
new_a_line
first_line $6thline
new_a_line
first_line $7thline
new_a_line
first_line "#####################################################################"
new_a_line
new_a_line
new_a_line



for {set j 0} {$j < [llength $whichone] } {incr j} {
  first_line "init station queue = [lindex $whichone $j] packets:"
  new_a_line 
  for {set k 0} {$k < 3 } {incr k} {
	for {set i 0} {$i < [llength $howmanyul] } {incr i} {
	        exec ns adt.tcl 400 [lindex $whichone $j] 1 4096 0 [expr 150+150*[lindex $howmanyul $i]] [lindex $howmanyul $i] $tcpvariant [lindex $pkts_short 0]  [lindex $ul_pkts_long 0]  [lindex $dl_pkts_long 0] >> "auto-result.txt" 2> /dev/null
	}
  }
}
