# ======================================================================
#
# TCL script for New TCP Via Multihop Multichannel Mesh
#
# ======================================================================
# Author:           Tianji Li
# Date:             31/07/2007
# Organization:     Hamilton Institute, NUIM, Ireland
# ======================================================================


set whichone 	     {99}
# set howmanyul	     {0 2 5 8 10  0  2  5  8  10}
# set howmanydl	     {1 1 1 1  1  10 10 10 10 10}
set howmanyul	     { 0  }
set howmanydl	     { 1  }
set runtime          500
# set wiredrtt	     {25 50 75 100 150}
set wiredrtt	     { 100 }
# set alpha            { 1000 100 10 8  5  3  1 1    1 }
# set beta             { 1    1   1  1  1  1  1 10   100 } 
set alpha            { 10 }
set beta             { 1 } 
set phyrate          54
set nullthres        0.01
set tcpvariant       "sack.astar"
set step             10

set aaa "+DATE(month/day/year): %m/%d/%Y, TIME: %H:%M:%S"
set systemtime       "[exec date $aaa]"
################ TXOP ####################


set 0stline  "# of DLs:      $howmanydl"
set 1stline  "# of ULs:      $howmanyul"
set 2ndline  "size of AP queue: $whichone"
set 3rdline  "tcp variant:   $tcpvariant"
set 4thline  $systemtime
set 5thline  "run time:      $runtime  seconds"
set 6thline  "wired rtt:     $wiredrtt  ms"
set 7thline  "phy rate:     54"
set 8thline  "step size:    $step"
set 9thline  "alpha:    $alpha"
set 10thline  "beta:    $beta"
set fh_bdp     "result.alt.doug.thru.txt"
set fh_srtt     "result.alt.doug.srtt.txt"

####################################################################
# clear result files
####################################################################
set fresult [open $fh_bdp "a"]
close $fresult 	
set fresult [open $fh_srtt "a"]
close $fresult 	

####################################################################
# put an 'enter' at the end of a line
####################################################################
proc new_a_line args {
    global fh_bdp fh_srtt
    
    set fresult [open $fh_bdp "a"]
    puts $fresult ""
    close $fresult 	
    set fresult [open $fh_srtt "a"]
    puts $fresult ""
    close $fresult 	
}


####################################################################
# the first line
####################################################################
proc first_line args {
    global fh_bdp fh_srtt
        for {set j 0} {$j < [llength "$args"] } {incr j} {
            set fresult1 [open $fh_bdp "a"]
            puts -nonewline $fresult1 "[lindex $args $j]      "
            close $fresult1
            set fresult1 [open $fh_srtt "a"]
            puts -nonewline $fresult1 "[lindex $args $j]      "
            close $fresult1
	}
}
new_a_line
new_a_line
new_a_line
new_a_line
first_line "#####################################################################"
new_a_line
first_line $0stline
new_a_line
first_line $1stline
new_a_line
first_line $2ndline
new_a_line
first_line $3rdline
new_a_line
first_line $4thline
new_a_line
first_line $5thline
new_a_line
first_line $6thline
new_a_line
first_line $7thline
new_a_line
first_line $8thline
new_a_line
first_line $9thline
new_a_line
first_line $10thline
new_a_line
first_line "#####################################################################"
new_a_line
new_a_line
new_a_line





 for {set i 0} {$i < [llength $howmanydl] } {incr i} {
 #         first_line "wired rtt = [lindex $wiredrtt $i] ms"
         for {set j 0} {$j < [llength $wiredrtt] } {incr j} {
 	        exec ns alt.doug.tcl 400 [lindex $whichone 0] 1 4096 0 $runtime [lindex $howmanydl $i] [lindex $howmanyul $i] $tcpvariant.a.[lindex $alpha 0].b.[lindex $beta 0] [lindex $wiredrtt $j] $nullthres $step [lindex $alpha 0] [lindex $beta 0] >> "auto-result.txt" 2> /dev/null
 	}
        new_a_line 
 }


#for {set i 0} {$i < [llength $alpha] } {incr i} {
#        first_line "a=[lindex $alpha $i], b=[lindex $beta $i]"
#        for {set j 0} {$j < [llength $howmanydl] } {incr j} {
#	        exec ns alt.doug.tcl 400 [lindex $whichone 0] 1 4096 0 $runtime [lindex $howmanydl $j] [lindex $howmanyul $j] $tcpvariant.a.[lindex $alpha $i].b.[lindex $beta $i] [lindex $wiredrtt 0] $nullthres $step [lindex $alpha $i] [lindex $beta $i] >> "auto-result.txt" 2> /dev/null
#	}
 #      new_a_line 
#}
