# ======================================================================
#
# TCL script for New TCP Via Multihop Multichannel Mesh
#
# ======================================================================
# Author:           Tianji Li
# Date:             31/07/2007
# Organization:     Hamilton Institute, NUIM, Ireland
# ======================================================================


set howmanyul	     { 10 }
set howmanydl	     { 1 }
set runtime          { 100 }
set wiredrtt	     { 100 }
set phyrate          54
set whichone 	     { 20 }
set tcpvariant       "sack.dcffix.withUL"
set aaa "+DATE(month/day/year): %m/%d/%Y, TIME: %H:%M:%S"
set systemtime       "[exec date $aaa]"
################ TXOP ####################


set 0stline  "# of DLs:      $howmanydl"
set 1stline  "# of ULs:      $howmanyul"
set 2ndline  "size of AP queue: $whichone"
set 3rdline  "tcp variant:   $tcpvariant"
set 4thline  $systemtime
set 5thline  "run time:      $runtime  seconds"
set 6thline  "wired rtt:     $wiredrtt  ms"
set 7thline  "phy rate:     $phyrate"
set fh_bdp     "result.fix.thru.txt"
set fh_srtt     "result.fix.srtt.txt"

####################################################################
# clear result files
####################################################################
set fresult [open $fh_bdp "a"]
close $fresult 	
set fresult [open $fh_srtt "a"]
close $fresult 	

####################################################################
# put an 'enter' at the end of a line
####################################################################
proc new_a_line args {
    global fh_bdp fh_srtt
    
    set fresult [open $fh_bdp "a"]
    puts $fresult ""
    close $fresult 	
    set fresult [open $fh_srtt "a"]
    puts $fresult ""
    close $fresult 	
}


####################################################################
# the first line
####################################################################
proc first_line args {
    global fh_bdp fh_srtt
        for {set j 0} {$j < [llength "$args"] } {incr j} {
            set fresult1 [open $fh_bdp "a"]
            puts -nonewline $fresult1 "[lindex $args $j]      "
            close $fresult1
            set fresult1 [open $fh_srtt "a"]
            puts -nonewline $fresult1 "[lindex $args $j]      "
            close $fresult1
	}
}
new_a_line
new_a_line
new_a_line
new_a_line
first_line "#####################################################################"
new_a_line
first_line $0stline
new_a_line
first_line $1stline
new_a_line
first_line $2ndline
new_a_line
first_line $3rdline
new_a_line
first_line $4thline
new_a_line
first_line $5thline
new_a_line
first_line $6thline
new_a_line
first_line $7thline
new_a_line
first_line "#####################################################################"
new_a_line
new_a_line
new_a_line




for {set i 0} {$i < [llength $howmanydl] } {incr i} {
        for {set j 0} {$j < [llength $whichone] } {incr j} {
	        exec ns dcf.fix.tcl 20 [lindex $whichone $j] 1 4096 0 $runtime [lindex $howmanydl $i] [lindex $howmanyul $i] $tcpvariant.limit.[lindex $whichone $j] [lindex $wiredrtt 0]  >> "auto-result.txt" 2> /dev/null
	}
       new_a_line 
}
